      ******************************************************************
      * Licensed materials - Property of IBM                           *
      * 5724-T07(C) Copyright IBM Corp. 2023                           *
      * All rights reserved                                            *
      * US Government users restricted rights  -  Use, duplication or  *
      * disclosure restricted by GSA ADP schedule contract with IBM    *
      * Corp.                                                          *
      *                                                                *
      * IBM Developer for z/OS(IDz)                                    *
      * IBM z/OS Automated Unit Testing Framework (zUnit)              *
      * Program: TOURCHK                                               *
      * Purpose: Check if tour code is valid, starts with 'A' or 'E'   *
      ******************************************************************
       IDENTIFICATION DIVISION.
        PROGRAM-ID. 'TOURCHK'.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       01 CMPTMPN PIC S9(9) COMP.
       01 CMPTMPI PIC S9(9) COMP.
       01 CHARTMP PIC X.
       01 SWAPPED PIC X.
       LINKAGE SECTION.
       01 TOUR-CODE             PIC X(03).
       01 RESULT-CODE   PIC X(01).
          88 CODE-VALID  VALUE 'V'.
          88 CODE-INVALID VALUE 'I'.
       PROCEDURE DIVISION USING TOUR-CODE RESULT-CODE.
       MAINLINE SECTION.
           IF TOUR-CODE(1:1) EQUAL "A" OR
               TOUR-CODE(1:1) EQUAL "E"
              DISPLAY 'TOUR-CODE VALID'
              SET CODE-VALID TO TRUE
           ELSE
              DISPLAY 'TOUR-CODE INVALID'
              SET CODE-INVALID TO TRUE
           END-IF
           .
       END PROGRAM 'TOURCHK'.